<template>
  <div class="supplierPay pagePadding">
    <ex-table
      v-loading="loading"
      v-if="powers && powers.length > 0 && powers.some((item) => item == '001')"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 0 80px">
            <el-col :span="24">
              <el-col :span="8" style="width: 300px">
                <el-input
                  :size="searchSize"
                  v-model="parmValue.name"
                  :maxlength="40"
                  placeholder="请输入公司名称/联系人"
                />
              </el-col>
              <el-col :span="4" style="width: 54px">
                <el-button
                  :size="searchSize"
                  type="primary"
                  class="fr"
                  icon="el-icon-search"
                  @click="searchList"
                />
              </el-col>
              <el-col
                :span="4"
                style="width: 66px"
                v-if="powers.some((item) => item == '024')"
              >
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
              <el-col
                :span="3"
                style="width: 66px; float: right"
                v-if="powers.some((item) => item == '002')"
              >
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
            </el-col>
          </el-row>
        </div>
      </template>

      <template #operation="{ scope }">
        <el-tooltip
          v-if="powers.some((item) => item == '007')"
           
          effect="dark"
          content="详情"
          placement="top"
        >
          <i
            class="el-icon-view tb-icon"
            @click="
              openModal(scope.row.id, scope.row.name, scope.row.contector, true)
            "
          ></i>
        </el-tooltip>
      </template>
    </ex-table>
    <no-auth v-else></no-auth>
    <!-- 弹窗 新增/修改 -->
    <add-edit
      :id="modelId"
      :show-model="showModel"
      :is-detail="isDetail"
      :contector="contector"
      :name="name"
      @refresh="searchList"
      @cancel="showModel = false"
    />
  </div>
</template>
<script>
import ExTable from "@/components/ExTableNew.vue";
import addEdit from "./addEdit";
import asyncRequest from "@/apis/service/purchase/supplierPay";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
export default {
  name: "supplierPay",
  mixins: [mixinPage, resToken],
  components: {
    ExTable,
    addEdit,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      let tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "supplierPay"
        ) || {};
      if (tran && tran.action && tran.action.length > 0) {
        return tran.action;
      } else {
        return [];
      }
    },
  },
  data() {
    return {
      name: "",
      contector: "",
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        name: "", // 账户
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "code",
          label: "供应商编码",
          width: "150px",
          fixed: "left",
        },
        {
          prop: "name",
          label: "公司名称",
        },
        {
          prop: "nature",
          label: "公司类型",
          width: "100px",
        },
        {
          prop: "contector",
          label: "联系人",
          width: "80px",
        },
        {
          prop: "post",
          label: "职务",
          width: "80px",
        },
        {
          prop: "mobile",
          label: "联系方式",
          width: "105px",
        },
        {
          prop: "address",
          label: "地址",
        },
        {
          prop: "addtime",
          label: "创建时间",
          sortable: true,
          width: "145px",
        },
        // {
        //   prop: "",
        //   label: "操作",
        //   width: "60px",
        //   fixed: "right",
        //   _noset_: true,
        //   _slot_: "operation",
        // },
      ],
    };
  },
  mounted() {
    this.searchList();
  },
  methods: {
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 10,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        name: "",
        page: 1, // 页码
        size: 10, // 每页显示条数
      };
      this.searchList();
    },
    // 新建/编辑/详情
    openModal(id, name, contector, isDetail) {
      this.contector = contector;
      this.name = name;
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     * @param {Boolean} type 是否有权限操作
     */
    async changeStatus(id, status, type) {
      if (!type) {
        return;
      }
      await this.$confirm(`确定要改为${status === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            roleid: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "状态修改成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },

    // 刷新表格
    async searchList() {
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped>
</style>
